#include <bits/stdc++.h>
#define endl '\n'
#define pii pair<int,int>
#define fi first
#define se second
#define int long long

using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n,q;
    cin>>n>>q;
    int a[n+1];
    vector<vector<int>>pref(32,vector<int>(n+1,0));
    for(int i=1;i<=n;i++){
        cin>>a[i];
        int msb=31-__builtin_clz(a[i]);
        for(int j=0;j<32;j++)pref[j][i]=pref[j][i-1];
        pref[msb][i]++;
    }
    while(q--){
        int l,r,cnt=0;
        cin>>l>>r;
        for(int i=31;i>=0;i--){
            cnt=pref[i][r]-pref[i][l-1];
            if(cnt)break;
        }
        cout<<cnt<<'\n';
    }
    return 0;
}